// OkUSBCamDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OkUSBCamDemo.h"
#include "OkUSBCamDemoDlg.h"
#include "Okapi32.h"
#include "SelectBoard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE				hBoard; //
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO			blk;
HWND				hWnd;
RECT				rect;
int                 TotalFrame = 0; //ɼ֡
int                 iCx, iCy;
int                 ComboParam; //ڲҪõ
int					TotalBoard = 0; //
long	            num = 0; //֡
float	            ratio = 25; //֡
bool                bInitFinish = FALSE; //Ƿɳʼ
bool                bActive = FALSE;
bool                bSaveImage = FALSE;
SCROLLINFO          InfoParamBar; //Ϣ
OKDEVTYPE           *lpOkDevInfo;
extern int			OpenBoardNo;
char                szFileName[128];
int                 RGBchannel = 0; //ɫͨ
BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form);
float exCalcCaptureRatio();
BOOL exGetSaveName(HWND hWnd, char *szFileName);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COkUSBCamDemoDlg dialog

COkUSBCamDemoDlg::COkUSBCamDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COkUSBCamDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COkUSBCamDemoDlg)
	m_ParamValue = 0;
	m_ParamMax = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COkUSBCamDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COkUSBCamDemoDlg)
	DDX_Control(pDX, IDC_SELVALUE, m_SelValue);
	DDX_Control(pDX, IDC_SELPARAM, m_SelectParam);
	DDX_Control(pDX, IDC_ADJUSTPARAM, m_ComboSetParam);
	DDX_Control(pDX, IDC_HSCRLPARAM, m_hParamBar);
	DDX_Control(pDX, IDC_IMAGE, m_image);
	DDX_Text(pDX, IDC_PARAMVALUE, m_ParamValue);
	DDX_Text(pDX, IDC_ParamMax, m_ParamMax);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COkUSBCamDemoDlg, CDialog)
	//{{AFX_MSG_MAP(COkUSBCamDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REOPEN, OnReopen)
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_BN_CLICKED(IDC_STOPCAPTURE, OnStopCapture)
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_ADJUSTPARAM, OnSelchangeCombosetparam)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_SELPARAM, OnSelchangeSelparam)
	ON_CBN_SELCHANGE(IDC_SELVALUE, OnSelchangeSelvalue)
	ON_BN_CLICKED(IDC_CAPTURESINGLE, OnCaptureSingle)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COkUSBCamDemoDlg message handlers

BOOL COkUSBCamDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here
	CRect imagerect;  
/////////////////////////////////////////////////////imageؼλ	
	GetDlgItem(IDC_IMAGE)->GetWindowRect(&imagerect);	
	ScreenToClient(&imagerect);
	GetDlgItem(IDC_IMAGE)->MoveWindow(imagerect.left, imagerect.top, 640, 480, true);		
//////////////////////////////////////////////////////////////////////
	lpbi = (LPBITMAPINFOHEADER)GlobalAlloc(GPTR, 1300*1024*8+5120);
	lpdib = (LPBYTE)lpbi + 5120;
	hWnd = AfxGetApp()->m_pMainWnd->m_hWnd;    
	UpdateData(FALSE);
    bInitFinish = TRUE;

    GetDlgItem(IDC_CAPTURE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPCAPTURE)->EnableWindow(FALSE);
    GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(FALSE);
    GetDlgItem(IDC_CAPTURESINGLE)->EnableWindow(FALSE);
    GetDlgItem(IDC_RESET)->EnableWindow(FALSE);
    GetDlgItem(IDC_SELPARAM)->EnableWindow(FALSE);
    GetDlgItem(IDC_SELVALUE)->EnableWindow(FALSE);
    GetDlgItem(IDC_ADJUSTPARAM)->EnableWindow(FALSE);
    GetDlgItem(IDC_HSCRLPARAM)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COkUSBCamDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COkUSBCamDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else //ͼʾˢ²
	{
		CDC *cdc;
		RECT rect;
		
		cdc = m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC, STRETCH_DELETESCANS);
  		okWaitVerticalSync(hBoard, 0);
		StretchDIBits(cdc->m_hDC,
			rect.left, rect.top,
			rect.right, rect.bottom, 
			0, 0, //horzstart, vertstart, 
			lpbi->biWidth, lpbi->biHeight,
			lpdib, (LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS, SRCCOPY);
		
 		ReleaseDC(cdc);
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COkUSBCamDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COkUSBCamDemoDlg::OnReopen() 
{
	// TODO: Add your control notification handler code here
	long		lParam = 0x2; //recheck 
    TotalBoard = okGetImageDevice(&lpOkDevInfo, (LPARAM)&lParam); //ӵok豸
	
	CSelectBoard showdlg; //ѡԻ
	showdlg.DoModal();
	
	MLONG iIndex = OpenBoardNo; 
	hBoard = okOpenBoard(&iIndex);	//

	if (hBoard)
	{
		GetDlgItem(IDC_BOARDNAME)->SetWindowText(lpOkDevInfo[OpenBoardNo].szBoardName); //ʾͺ
		GetDlgItem(IDC_CAPTURE)->EnableWindow(TRUE);
		GetDlgItem(IDC_STOPCAPTURE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CAPTURESINGLE)->EnableWindow(TRUE);		
		GetDlgItem(IDC_RESET)->EnableWindow(TRUE);		
		GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(TRUE);
		GetDlgItem(IDC_SELPARAM)->EnableWindow(TRUE);
		GetDlgItem(IDC_SELVALUE)->EnableWindow(TRUE);
		GetDlgItem(IDC_ADJUSTPARAM)->EnableWindow(TRUE);
		GetDlgItem(IDC_HSCRLPARAM)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_CAPTURE)->EnableWindow(FALSE);
		MessageBox("ûзOK_USBͷ", NULL, MB_OK);
		GetDlgItem(IDC_STOPCAPTURE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CAPTURESINGLE)->EnableWindow(FALSE);		
		GetDlgItem(IDC_RESET)->EnableWindow(FALSE);		
		GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(FALSE);
	}
	///////////////////////////////////////////////////////////////////////ؼʼ
 	m_ComboSetParam.SetCurSel(0); //ڲȣ
    OnSelchangeCombosetparam();
 	m_SelectParam.SetCurSel(0); //ѡRGBʽ
    OnSelchangeSelparam();
	//////////////////////////////////////////////////////////////////////ʼ
 	InfoParamBar.cbSize = sizeof(SCROLLINFO);
 	InfoParamBar.fMask = SIF_ALL;
 	InfoParamBar.nMin = 0;
 	InfoParamBar.nMax = 255+16-1;
 	InfoParamBar.nPage =16;
 	InfoParamBar.nPos = m_ParamValue;
 	InfoParamBar.nTrackPos=0;
 	m_hParamBar.SetScrollInfo(&InfoParamBar);
	/////////////////////////////////////////////////////////////////////ڰɫͶ
	if ((lpOkDevInfo[OpenBoardNo].iBoardTypeCode / 10000) % 10 == 0) //ڰ
	{
		m_SelectParam.DeleteString(3);
		m_SelectParam.InsertString(3, "ѡRGB/UV");
	}
}

void COkUSBCamDemoDlg::OnCapture() 
{
	// TODO: Add your control notification handler code here
	okSetSeqCallback(hBoard, BeginCapture, Process, EndCapture);//ûص
	if (okCaptureTo(hBoard, BUFFER, 0, -1))//ɼ
	{
		bActive = TRUE;
	}
	GetDlgItem(IDC_CAPTURE)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPCAPTURE)->EnableWindow(TRUE);
}

void COkUSBCamDemoDlg::OnStopCapture() 
{
	// TODO: Add your control notification handler code here
	okStopCapture(hBoard); //ֹͣɼ
	bActive = FALSE;
	GetDlgItem(IDC_CAPTURE)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOPCAPTURE)->EnableWindow(FALSE);
}

void COkUSBCamDemoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);	
	// TODO: Add your message handler code here
	int iWid = 0, iHgt = 0; //imageؼ

	if(iCx == 0 || iCy == 0)
    {
        iCx = cx;
        iCy = cy;
    }
    else if(cx == 0 && cy == 0)
    {
    }
	else if (bInitFinish)
	{
		m_image.GetClientRect(&rect); //õimageؼλ
		
		float systemratio, compareratio; //õĻֱ
        systemratio = (float)GetSystemMetrics(SM_CXSCREEN)/(float)GetSystemMetrics(SM_CYSCREEN);
        compareratio = (float)4.0/(float)3.0;

		if (systemratio > compareratio) //¼
		{
			iHgt = rect.bottom - rect.top - (iCy - cy);
			iWid = iHgt*4/3;
		}
		else
		{
			iWid = rect.right - rect.left - (iCx - cx);
			iHgt = iWid*3/4;
		}
		
        m_image.SetWindowPos(NULL,0,0,iWid,iHgt,SWP_NOMOVE); //imageؼλ

		iCx = cx;
		iCy = cy;		
	}
}

void COkUSBCamDemoDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	okCloseBoard(hBoard); //ر
	CDialog::OnClose();
}

void COkUSBCamDemoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int minpos;
	int maxpos;
	RECT bufrect;
    int  valuetemp1, valuetemp2;
	pScrollBar->GetScrollRange(&minpos, &maxpos); 
//	maxpos = pScrollBar->GetScrollLimit();
	
	// Get the current position of scroll box.
	int curpos = pScrollBar->GetScrollPos();
	
	// Determine the new position of scroll box.
	switch (nSBCode)
	{
	case SB_LEFT:    // Scroll to far left.
		curpos = minpos;
		break;		
	case SB_RIGHT:    // Scroll to far right.
		curpos = maxpos;
		break;		
	case SB_ENDSCROLL:  // End scroll.
		
		break;		
	case SB_LINELEFT:    // Scroll left.
		if (curpos > minpos)
			curpos--;
		break;		
	case SB_LINERIGHT:  // Scroll right.
		if (curpos < maxpos)
			curpos++;
		break;		
	case SB_PAGELEFT:   // Scroll one page left.
		{
			// Get the page size. 
			SCROLLINFO  info;
			pScrollBar->GetScrollInfo(&info, SIF_ALL);
			
			if (curpos > minpos)
				curpos = max(minpos, curpos - (int) info.nPage);
		}
		break;		
	case SB_PAGERIGHT:    // Scroll one page right.
		{
			// Get the page size. 
			SCROLLINFO  info;
			pScrollBar->GetScrollInfo(&info, SIF_ALL);
			
			if (curpos < maxpos)
				curpos = min(maxpos, curpos + (int) info.nPage);
		}
		break;		
	case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
		curpos = nPos;      // of the scroll box at the end of the drag 
		// operation.
		break;		
	case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is 
		// the
		curpos = nPos;     // position that the scroll box has been dragged 
		// to.
		break;
	}
	pScrollBar->SetScrollPos(curpos); //ù
	if (pScrollBar->GetDlgCtrlID()==IDC_HSCRLPARAM)
	{
		m_ParamValue = curpos;
		switch (m_ComboSetParam.GetCurSel())
		{
		case 0: //
		case 1: //Աȶ
            if ((lpOkDevInfo[OpenBoardNo].iBoardTypeCode / 10000) % 10 == 0) //ڰ
			{
				okSetVideoParam(hBoard, ComboParam, m_ParamValue);
			}
			else //ɫ
			{
				switch(RGBchannel)
				{
					case 0: //ͨ
						okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue, 0));
						break;
					case 1: //ͨ
						okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue, 1));
						break;
					case 2: //ͨ
						okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue, 2));
						break;
					case 3: //ȫͨ
						//////////////////////////////////////////////////////////////////////////
						valuetemp1 = okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue, 0));
						//////////////////////////////////////////////////////////////////////////
                        valuetemp2 = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x0000ff00) >> 8;
						okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue-valuetemp1+valuetemp2, 1));
						//////////////////////////////////////////////////////////////////////////
                        valuetemp2 = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x00ff0000) >> 16;
						okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue-valuetemp1+valuetemp2, 2));
						break;						
				}
			}
			break;
		case 2: //Чxƫ
			okSetVideoParam(hBoard, ComboParam, MAKELONG(m_ParamValue, HIWORD(okSetVideoParam(hBoard, ComboParam, -1))));
			break;
		case 3: //Чyƫ
			okSetVideoParam(hBoard, ComboParam, MAKELONG(LOWORD(okSetVideoParam(hBoard, ComboParam, -1)), m_ParamValue));
			break;
		case 4: //ɼĿ
			OnStopCapture();
			bufrect.right = -1;
			okSetTargetRect(hBoard, BUFFER, &bufrect);
			bufrect.right = m_ParamValue;
 			okSetTargetRect(hBoard, BUFFER, &bufrect);
			break;
		case 5: //ɼĿ߶
			OnStopCapture();
			bufrect.right = -1;
			okSetTargetRect(hBoard, BUFFER, &bufrect);
			bufrect.bottom = m_ParamValue;
			okSetTargetRect(hBoard, BUFFER, &bufrect);
			break;
		}
	UpdateData(FALSE);	
	}	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COkUSBCamDemoDlg::OnSelchangeCombosetparam() //ڲ
{
	// TODO: Add your control notification handler code here
    switch (m_ComboSetParam.GetCurSel())
	{
	case 0: //
		ComboParam = VIDEO_BRIGHTNESS;
		if ((lpOkDevInfo[OpenBoardNo].iBoardTypeCode / 10000) % 10 == 0) //ڰ
		{
			m_ParamValue = okSetVideoParam(hBoard, ComboParam, -1);
		}
		else
		{
			switch (RGBchannel)
			{
			case 0: // 
			case 3: // ȫͨ
                m_ParamValue = (okSetVideoParam(hBoard, ComboParam, -1))  & 0x000000ff;
				break;
			case 1: //
				m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x0000ff00) >> 8;
				break;
			case 2: //
				m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x00ff0000) >> 16;
				break;
			}
		}
		InfoParamBar.nMax = 255+16-1; 
		m_ParamMax = 255;
		break;

	case 1: //Աȶ
		ComboParam = VIDEO_CONTRAST;
		if ((lpOkDevInfo[OpenBoardNo].iBoardTypeCode / 10000) % 10 == 0) //ڰ
		{
			m_ParamValue = okSetVideoParam(hBoard, ComboParam, -1);
		}
		else
		{
			switch (RGBchannel)
			{
			case 0: // 
			case 3: // ȫͨ
                m_ParamValue = (okSetVideoParam(hBoard, ComboParam, -1))  & 0x000000ff;
				break;
			case 1: //
				m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x0000ff00) >> 8;
				break;
			case 2: //
				m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x00ff0000) >> 16;
				break;
			}
		}		
		InfoParamBar.nMax = 255+16-1; 
		m_ParamMax = 255;
		break;

	case 2: //ЧXƫ
		ComboParam = VIDEO_RECTSHIFTEX;
		m_ParamValue = LOWORD(okSetVideoParam(hBoard, ComboParam, -1));
		InfoParamBar.nMax = 2048+16-1; 
		m_ParamMax = 2048;
		break;

	case 3: //ЧYƫ
		ComboParam = VIDEO_RECTSHIFTEX;
		m_ParamValue = HIWORD(okSetVideoParam(hBoard, ComboParam, -1));
		InfoParamBar.nMax = 1024+16-1; 
		m_ParamMax = 1024;
		break;
	case 4: //ɼĿ
		rect.right = -1;
		okSetTargetRect(hBoard, BUFFER, &rect); //õĴС
		m_ParamValue = rect.right-rect.left;
		InfoParamBar.nMax = LOWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1))+16-1; 
		m_ParamMax = LOWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1));		
		break;
	case 5: //ɼĿ߶
		rect.right = -1;
		okSetTargetRect(hBoard, BUFFER, &rect); //õĴС
		m_ParamValue = rect.bottom-rect.top;
		InfoParamBar.nMax = HIWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1))+16-1; 
		m_ParamMax = HIWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1));
		break;
	}
	
	InfoParamBar.nPos = m_ParamValue;
    m_hParamBar.SetScrollInfo(&InfoParamBar); //ù		
	UpdateData(FALSE);
}

void COkUSBCamDemoDlg::OnSelchangeSelparam() //ò
{
	// TODO: Add your control notification handler code here
	int			iCnt = 0;
	int         iComboCnt=0;
	int         BufFormat, BufFormatNum;
	int         ExposeTime;
	int         SignalType;

    iComboCnt = m_SelValue.GetCount();

	for (iCnt=0;iCnt<iComboCnt;iCnt++)//ɾǰ
	{
		m_SelValue.DeleteString(0);
	}

	GetDlgItem(IDC_SELVALUE)->EnableWindow(TRUE);

	switch(m_SelectParam.GetCurSel()) //õϿǰѡ
	{
	case 0: //RGBʽ
		m_SelValue.AddString("Gray8");
		m_SelValue.AddString("Gray10");
		m_SelValue.AddString("Gray12");
		m_SelValue.AddString("Gray14");
		m_SelValue.AddString("Gray16");
		m_SelValue.AddString("RGB888");
		m_SelValue.AddString("RGB8888");
        
        BufFormat = LOWORD(okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, -1)); //֮ǰ
		switch(BufFormat)
		{
		case 1:
			BufFormat = FORM_RGB888;
			BufFormatNum = 5;
			break;
		case 4:
			BufFormat = FORM_RGB8888;
			BufFormatNum = 6;
			break;
		case 15:
			BufFormat = FORM_GRAY10;
			BufFormatNum = 1;
			break;
		case 16:
			BufFormat = FORM_GRAY12;
			BufFormatNum = 2;
			break;
		case 17:
			BufFormat = FORM_GRAY14;
			BufFormatNum = 3;
			break;
		case 18:
			BufFormat = FORM_GRAY16;
			BufFormatNum = 4;
			break;
		default:
			BufFormat = FORM_GRAY8;
			BufFormatNum = 0;
			break;
		}
		m_SelValue.SetCurSel(BufFormatNum);
		break;
	case 1: //عʱ(ǾȷֵŷΧ)
		m_SelValue.AddString("5");
		m_SelValue.AddString("10");
		m_SelValue.AddString("20");
		m_SelValue.AddString("30");
		m_SelValue.AddString("40");
		m_SelValue.AddString("50");
		m_SelValue.AddString("60");
		m_SelValue.AddString("100");

		ExposeTime = okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, -1);
		if (ExposeTime <= 7500) //5
		{
			m_SelValue.SetCurSel(0);
		}
        else if (ExposeTime <= 15000) //10
        {
			m_SelValue.SetCurSel(1);
        }
		else if (ExposeTime <=25000) //20
		{
			m_SelValue.SetCurSel(2);
		}
		else if (ExposeTime <=35000) //30
		{
			m_SelValue.SetCurSel(3);
		}
		else if (ExposeTime <=45000) //40
		{
			m_SelValue.SetCurSel(4);
		}
		else if (ExposeTime <=55000) //50
		{
			m_SelValue.SetCurSel(5);
		}
		else if (ExposeTime <=80000) //60
		{
			m_SelValue.SetCurSel(6);
		}
		else //100
		{
			m_SelValue.SetCurSel(7);
		}
		break;
	case 2: //źԴģʽ
		m_SelValue.AddString("ź");
		m_SelValue.AddString("ģʽź");
		SignalType = okSetCaptureParam(hBoard, CAPTURE_TRIGCAPTURE, -1);
		switch(SignalType)
		{
		case 0:
			m_SelValue.SetCurSel(0); //ź
			break;
		case 1:
			m_SelValue.SetCurSel(1); //ģʽź
            break;
		}
		break;
	case 3: //ѡRGB/UV
		if ((lpOkDevInfo[OpenBoardNo].iBoardTypeCode / 10000) % 10 == 0) //ڰ
		{
			GetDlgItem(IDC_SELVALUE)->EnableWindow(FALSE);
		}
		else
		{
			m_SelValue.AddString("ͨB/C");
			m_SelValue.AddString("ͨB/C");
			m_SelValue.AddString("ͨB/C");
			m_SelValue.AddString("ȫͨ");
		    m_SelValue.SetCurSel(0);
		}
		break;
	}
}

void COkUSBCamDemoDlg::OnSelchangeSelvalue() 
{
	// TODO: Add your control notification handler code here
	Sleep(500);
	switch(m_SelectParam.GetCurSel())
	{
	case 0: //ûRGBʽ
		switch(m_SelValue.GetCurSel())
		{
		case 0:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY8);
			break;
		case 1:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY10);
			break;
		case 2:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY12);
			break;
		case 3:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY14);
			break;
		case 4:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY16);
			break;
		case 5:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_RGB888);
			break;
		case 6:
			okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_RGB8888);
			break;
		}
		break;
	case 1: //عʱ
		switch(m_SelValue.GetCurSel())
		{
		case 0:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 5000);
			break;
		case 1:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 10000);
			break;
		case 2:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 20000);
			break;
		case 3:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 30000);
			break;
		case 4:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 40000);
			break;
		case 5:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 50000);
			break;
		case 6:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 60000);
			break;
		case 7:
			okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, 100000);
			break;
		}
		break;
	case 2: //źԴģʽ
		switch(m_SelValue.GetCurSel())
		{
		case 0: //
			okSetCaptureParam(hBoard, CAPTURE_TRIGCAPTURE, 0);
			break;
		case 1: //ⴥ
			okStopCapture(hBoard);
			okSetCaptureParam(hBoard, CAPTURE_TRIGCAPTURE, 1);
			int a = okSetCaptureParam(hBoard, CAPTURE_TRIGCAPTURE, -1);
			if (bActive)
			{			
				OnCapture();
			}
			break;
		}
		break;
	case 3: //õRGB/UV
		switch(m_SelValue.GetCurSel())
		{
		case 0:
			RGBchannel = 0; //
			m_ParamValue = (okSetVideoParam(hBoard, ComboParam, -1))  & 0x000000ff;
			InfoParamBar.nPos = m_ParamValue;
			m_hParamBar.SetScrollInfo(&InfoParamBar); //ù		
			UpdateData(FALSE);
			break;
		case 1:
			RGBchannel = 1; //
			m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x0000ff00) >> 8;
			InfoParamBar.nPos = m_ParamValue;
			m_hParamBar.SetScrollInfo(&InfoParamBar); //ù		
			UpdateData(FALSE);
			break;
		case 2:
			RGBchannel = 2; //
			m_ParamValue = ((okSetVideoParam(hBoard, ComboParam, -1)) & 0x00ff0000) >> 16;
			InfoParamBar.nPos = m_ParamValue;
			m_hParamBar.SetScrollInfo(&InfoParamBar); //ù		
			UpdateData(FALSE);
			break;
		case 3:
			RGBchannel = 3; //ȫͨ
			m_ParamValue = (okSetVideoParam(hBoard, ComboParam, -1))  & 0x000000ff;
			InfoParamBar.nPos = m_ParamValue;
			m_hParamBar.SetScrollInfo(&InfoParamBar); //ù		
			UpdateData(FALSE);
			break;
		}
		break;
	}
}

void COkUSBCamDemoDlg::OnCaptureSingle() //֡
{
	// TODO: Add your control notification handler code here
    OnStopCapture(); //ֹͣɼ
	okCaptureTo(hBoard, BUFFER, 0, 1); //֡
	okGetCaptureStatus(hBoard, 1); //ȴɼ
	BeginCapture(hBoard); 
	okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, 0, 1);
 	InvalidateRect(NULL, FALSE);
}

BOOL CALLBACK BeginCapture(HANDLE hBoard) //صʼ
{
	short	width, height;
	long	form;
	
	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form));
	blk.lpBits = lpdib;
	blk.iBitCount = lpbi->biBitCount;
	blk.iHeight = -(short)lpbi->biHeight;
	blk.iWidth = (short)lpbi->biWidth;
	
	return 1;
}

BOOL CALLBACK Process(HANDLE hBoard,long no) //صɼ
{	
 	char WindowText[100];
 	sprintf(WindowText, "Ratio=%5.2f; Total frames=%3d; Current =%3d ", exCalcCaptureRatio(), TotalFrame, no); //ʾ֡
 	SetWindowText(hWnd, WindowText);
	okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, no, 1);
 	GetWindowRect(GetDlgItem(hWnd, IDC_IMAGE), &rect);
	ScreenToClient(hWnd, (LPPOINT)&rect);
 	InvalidateRect(hWnd, &rect, FALSE);
	if (bSaveImage) //ͼ
	{
		okSaveImageFile(hBoard, szFileName, 0, BUFFER, no, 1);
		bSaveImage = FALSE;
	}
 	TotalFrame++; //ܲɼ֡
	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard) //ص
{
	okSetSeqCallback(hBoard, NULL, NULL, NULL);
	return 1;
}

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;
	if ( (tgt == SCREEN ) || (tgt == BUFFER) )
	{
		rect.right = -1;
		okSetTargetRect(hBoard, tgt, &rect); //get current rect
		if(width)
			*width = (short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);
		if(tgt==SCREEN ) 
		{
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1
		
	} else if(tgt>BUFFER)
	{ //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;
		
		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}
	
	return form;
}

BOOL exGetSaveName(HWND hWnd, char *szFileName) //ļ
{
	OPENFILENAME ofn;	 
	char		*szFilter=
		"BMP file (*.BMP)\0*.BMP\0"
		"Jpeg format file (*.JPG)\0*.JPG\0"
// 		"Sequence file (*.SEQ)\0*.SEQ\0"
// 		"Sequence file in JPEG (*.SEQ)\0*.SEQ\0"
// 		"Audio-video interleaved (*.AVI)\0*.AVI\0"
// 		"Compressed AVI in MJPEG  (*.AVI)\0*.AVI\0"
// 		"Compressed AVI in MPEG4  (*.AVI)\0*.AVI\0"
		"Raw format files (*.RAW)\0*.RAW\0";
	
    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
    ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 128;
	ofn.lpstrDefExt		= "bmp";
	
    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	
    if (!GetSaveFileName((LPOPENFILENAME)&ofn)) 
	{
		return FALSE;
	}
	
	if( !strnicmp(strrchr(szFileName,'.'),".seq",4) ||
		!strnicmp(strrchr(szFileName,'.'),".avi",4) ||
		!strnicmp(strrchr(szFileName,'.'),".m2v",4) 
		)  
	{
		//first delete ok.seq or .avi
		DeleteFile(szFileName);							
	}
	
	if(ofn.nFilterIndex==4) 
	{ //seq file in jpeg data
		strcat(szFileName,",jpg,50"); //quality=50
	}
	else if(ofn.nFilterIndex==6) 
	{ //avi in mjpg
		strcat(szFileName,",mjpg,60"); //mjpeg
	}
	else if(ofn.nFilterIndex==7) 
	{ //avi in mpeg4
		strcat(szFileName,",mpg4"); //mpeg4
	}
	
	return TRUE;
}

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;
	
	if(!lpbi)
		return FALSE;
	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align
	
	lpbi->biWidth=width;
	lpbi->biHeight=height;
	
	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;
	
	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;
	
	
	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);
		
		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);
		
		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;
		
		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;
	
	return lpbi->biClrUsed;
}

float exCalcCaptureRatio() //֡
{
	static	DWORD	times;

	if( (num>=12) ||  ((okGetTickCount()-times)>2000)&&(num>=2) ) 
	{
		times=okGetTickCount()-times;
		ratio=((float)num*1000/times);
		num=0;
	}
	
	if(num==0)
		times=okGetTickCount();
	num++;
	
	return ratio;
}


void COkUSBCamDemoDlg::OnReset() //ʼ
{
	// TODO: Add your control notification handler code here
    OnStopCapture();
	okSetCaptureParam(hBoard, CAPTURE_RESETALL, 0);
	okSetVideoParam(hBoard, VIDEO_RESETALL, 0);
	///////////////////////////////////////////////////////////////////////ؼʼ
	m_ComboSetParam.SetCurSel(0); //ڲȣ
    OnSelchangeCombosetparam();
	m_SelectParam.SetCurSel(0); //ѡRGBʽ
    OnSelchangeSelparam();
	//////////////////////////////////////////////////////////////////////ʼ
	InfoParamBar.cbSize = sizeof(SCROLLINFO);
	InfoParamBar.fMask = SIF_ALL;
	InfoParamBar.nMin = 0;
	InfoParamBar.nMax = 255+16-1;
	InfoParamBar.nPage =16;
	InfoParamBar.nPos = m_ParamValue;
	InfoParamBar.nTrackPos=0;
	m_hParamBar.SetScrollInfo(&InfoParamBar);

}

void COkUSBCamDemoDlg::OnSaveimage() 
{
	// TODO: Add your control notification handler code here
	exGetSaveName(hWnd, szFileName); //ļ
	if (bActive)
	{
        bSaveImage = TRUE;
	}
	else
	{
		okSaveImageFile(hBoard, szFileName, 0, BUFFER, 0, 1); //ļ
	}
}
