// SelectBoard.cpp : implementation file
//

#include "stdafx.h"
#include "OkUSBCamDemo.h"
#include "SelectBoard.h"
#include "Okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int TotalBoard;
extern 	OKDEVTYPE	*lpOkDevInfo;
int OpenBoardNo;

/////////////////////////////////////////////////////////////////////////////
// CSelectBoard dialog


CSelectBoard::CSelectBoard(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectBoard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectBoard)
	m_TotalBoard = 0;
	//}}AFX_DATA_INIT
}


void CSelectBoard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectBoard)
	DDX_Control(pDX, IDC_BOARDLIST, m_BoardList);
	DDX_Text(pDX, IDC_TOTALBOARD, m_TotalBoard);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectBoard, CDialog)
	//{{AFX_MSG_MAP(CSelectBoard)
	ON_CBN_SELCHANGE(IDC_BOARDLIST, OnSelchangeBoardlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectBoard message handlers

BOOL CSelectBoard::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString			csBoardInfo;
	INT32			iCnt = 0;
	
    m_TotalBoard = TotalBoard;
	UpdateData(FALSE);
	for(iCnt = 0 ; iCnt < m_TotalBoard ; iCnt++)
	{ /*add find GigE Camera to Cameras list*/
		csBoardInfo.Format("No.%d   Type: %s   ID: %d ",
			iCnt,
			lpOkDevInfo[iCnt].szBoardName,
			lpOkDevInfo[iCnt].iBoardTypeCode);
		m_BoardList.AddString(csBoardInfo);
	}
	m_BoardList.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectBoard::OnSelchangeBoardlist() 
{
	// TODO: Add your control notification handler code here
	OpenBoardNo = m_BoardList.GetCurSel();
}
